# Function to calculate the possible cost per day for the guest's stay
def find_cost_per_day(total_cost, total_days):
    # If the total days are 1, then the cost per day is the total cost itself
    if total_days == 1:
        return total_cost

    # Calculate the possible range of cost per day
    min_cost = total_cost // total_days
    max_cost = min_cost + (1 if total_cost % total_days > 0 else 0)

    return max_cost  # Returning the maximum possible cost per day

# Reading input
total_days, total_cost = map(int, input().split())

# Calculate and print the possible cost per day
result = find_cost_per_day(total_cost, total_days)
print(result)
