#include <bits/stdc++.h>

/*

#.#.#.....
.......##.
.#..#.....
.#........
.#..##....
..........
####...#..
.......#..
.......#..
##........

*/

using namespace std;

int main()
{
    int n = 10, m = 10;
    char a[12][12];

    bool good = true;

    for(int i=1;i<=n;i++) {
        for(int j=1;j<=m;j++) {
            cin >> a[i][j];
        }
    }

    for(int i=1;i<=n;i++) {
        for(int j=1;j<=m;j++) {
            if (a[i][j] == '.')
                continue;
            if (a[i-1][j-1] == '#' || a[i + 1][j-1] == '#' || a[i-1][j + 1] == '#' || a[i + 1][j + 1] == '#') {
                good = false;
                //cout << "N$" << endl;
            }
        }
    }

    bool used[12][12]{};

    int dx[4] = {0, 0, 1, -1};
    int dy[4] = {1, -1, 0, 0};

    int f[5]{};

    for(int i=1;i<=n;i++) {
        for(int j=1;j<=m;j++) {
            int sz = 0;
            if (used[i][j] == 0 && a[i][j] == '#') {
                used[i][j] = 1;
                queue<pair<int, int> > q;
                q.push(make_pair(i, j));
                while(!q.empty()) {
                    sz += 1;
                    int nx = q.front().first;
                    int ny = q.front().second;
                    //cout << "(" << nx << " " << ny << ")" << endl;
                    q.pop();
                    for(int x=0;x<4;x++) {
                        if (a[nx + dx[x]][ny + dy[x]] == '#' && used[nx + dx[x]][ny + dy[x]] == 0) {
                            used[nx + dx[x]][ny + dy[x]] = 1;
                            q.push(make_pair(nx + dx[x], ny + dy[x]));
                        }
                    }
                }
            }
            if (sz > 4) {
                good = false;
            }
            else{
                f[sz] += 1;
            }
        }
    }

    if (f[1] != 4 || f[2] != 3 || f[3] != 2 || f[4] != 1)
        good = false;

    if (good == false)
        cout << "NO\n";
    else
        cout << "YES\n";

    return 0;
}
