def find_min_cost(n, heights, costs):
    min_cost = [0] * (n+1)  # минимальная стоимость накрытия первых i колонн
    max_height = [0] * (n+1)  # максимальная высота среди первых i колонн

    for i in range(1, n+1):
        min_cost[i] = float('inf')
        max_height[i] = max(heights[i-1], max_height[i-1])  # обновляем максимальную высоту

        for j in range(1, i+1):
            min_cost[i] = min(min_cost[j-1] + costs[j-1] + (max_height[i] - max_height[j]), min_cost[i])

    return min_cost[n]

# Пример использования
n = int(input())
heights = list(map(int, input().split()))
costs = list(map(int, input().split()))

result = find_min_cost(n, heights, costs)
print(result)