def is_valid_battleship_placement(field):
    ship_lengths = [4, 3, 3, 2, 2, 2, 1, 1, 1, 1]
    rows, cols = 10, 10
    ship_count = [0] * 10  # Счетчик количества кораблей каждой длины

    for row in range(rows):
        for col in range(cols):
            if field[row][col] == '#':
                ship_count[0] += 1  # Увеличиваем счетчик кораблей длины 1
                for length in range(1, 10):
                    if (row + 1 < rows and field[row + 1][col] == '#') or (col + 1 < cols and field[row][col + 1] == '#'):
                        break  # Нашли конец корабля
                    ship_count[length] += 1  # Увеличиваем счетчик кораблей длины length

    return ship_count == ship_lengths

field = []
for _ in range(10):
    field.append(input())

if is_valid_battleship_placement(field):
    print("YES")
else:
    print("NO")
