def mirror_floor_number(k):
    # Преобразуем номер этажа в строку, инвертируем ее и создаем словарь для отражений
    floor_str = str(k)
    mirror_dict = {'0': '0', '1': '1', '2': '5', '5': '2', '8': '8', '9': '6', '6': '9'}

    # Инициализируем строку для отображения в зеркале
    mirror_str = ""

    # Проходим по символам строки, инвертируем их и добавляем к результату
    for char in reversed(floor_str):
        if char in mirror_dict:
            mirror_str += mirror_dict[char]
        else:
            return -1  # Если символ не может быть отражен, вернем -1

    # Преобразуем полученную строку в целое число
    mirror_number = int(mirror_str)

    return mirror_number

# Ввод номера этажа
k = int(input())

# Получение результата
result = mirror_floor_number(k)

# Вывод результата без ведущих нулей
if result != -1:
    print(result)
else:
    print("Невозможно отобразить")
