#include <bits/stdc++.h>
 
#define file(s) if (fopen(s".in", "r")) freopen(s".in", "r", stdin), freopen(s".out", "w", stdout)
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int)x.size()
#define F first
#define S second
#define int long long

const int maxn = 1e5+7;
const int inf = 1e18;
const int mod = 1e9+7;
  
using namespace std;

int n, m;
long double r;
pair<int, long double> p[maxn];
long double ans[maxn];

void solve(){
	cin >> n >> m >> r;
	for(int i = 1; i <= n; i++){
		cin >> p[i].F >> p[i].S;
	}
	cout.precision(6);
	sort(p + 1, p + 1 + n, [&](pair<int, long double> i, pair<int, long double> j){
		return i.F < j.F;
	});
	for(int i = 1; i <= n; i++){
		long double cur = ans[p[i - 1].F] * (pow((1 - r), (p[i].F - 1) - p[i - 1].F));
		ans[p[i].F] = cur * (1 - r) + p[i].S * r;
	}
	while(m--){
		int pos;
		cin >> pos;
		int L = 1, R = n, res = 0;
		while(L <= R){
			int md = (L + R) / 2;
			if(p[md].F <= pos){
				res = md;
				L = md + 1;
			}else{
				R = md - 1;
			}
		}
		if(pos < p[1].F){
			cout << 0 << ' ';
			continue;
		}
		if(p[res].F == pos){
			cout << ans[p[res].F] << ' ';
			continue;
		}
		long double cur = ans[p[res].F] * (pow((1 - r), pos - p[res].F));
		cout << fixed << cur << ' ';
	}
}
 
signed main(){
    int test = 1;
    // cin >> test;
    while(test--){
        solve();
    }
}