﻿#include<iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <algorithm>
#include <map>
#include <deque>
#define int long long
#define double long double
using ll = long long;
using namespace std;
const int mod = 1e9 + 7;
const int INF = 1e9 + 7;
#define get_time (double)clock() / (double)(CLOCKS_PER_SEC)
#ifndef ONLINE_JUDGE
#define debug(x) //cerr << (#x) << ": " << x << endl;
#else
#define debug(x)
#endif
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll bs_sqrt(ll x) {
    ll left = 0, right = 2000000123;
    while (right > left) {
        ll mid = (left + right) / 2;
        if (mid * mid > x) {
            right = mid;
            continue;
        }
        left = mid + 1;
    }
    return left - 1;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = bin_pow(a, n / 2);
        return (t * t);
    }
    else {
        ll t = bin_pow(a, n - 1);
        return (t * a);
    }
}
int cur = 1;
vector<vector<int>> gr;
vector<int> ans;
void perebor(int v, int level, int in) {
    if (cur == 0) return;
    if (level == 0) return;
    int a = gr[level - 1][in];
    if (a > v) {
        perebor(v, level - 1, in * 2);
        perebor(a, level - 1, in * 2 + 1);
        if (level == 1) {
            ans[in * 2] = v;
            ans[in * 2 + 1] = a;
        }
    }
    else {
        cur = 0;
    }
}
bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.first > b.first) return 0;
    else if (a.first < b.first) return 1;
    else {
        if (a.second < b.second) return 0;
        else return 1;
    }
}
void solve1() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    if (n == 1) {
        cout << a[0];
        return;
    }
    map<int, int> m;
    for (auto c : a) {
        m[c]++;
    }
    if ((m.size() * 2 - 1) != n) {
        cout << -1;
        return;
    }
    int col = m.size();
    ans.resize(col);
    if ((col * 2 - 1) != n) {
        cout << -1;
        return;
    }
    gr.resize(n);
    vector<pair<int, int>> v;
    int number = 10000000000, lev = 0;
    for (auto c : m) {
        v.push_back({ c.second,c.first });
        number = min(number, c.first);
        lev = max(lev, c.second);
    }
    sort(v.rbegin(), v.rend(), cmp);
    for (auto c : v) {
        gr[c.first - 1].push_back(c.second);
    }
    debug(number);
    debug(lev);
    perebor(number, lev - 1, 0);
    if (cur == 0) {
        cout << "-1";
        exit(0);
    }
    else {
        for (auto c : ans) {
            cout << c << " ";
        }
    }
}
signed main() {
    /*
    #ifdef ONLINE_JUDGE
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    #endif
    */
    cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve1();
    }
    return 0;
}