#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<long long, long long>

const int N = 2e+5 + 1;

int n;

int arr[N / 2];

unordered_map < int, set < int > > v;

void Build(int x, int lx, int rx, int num, int k) {
    if (lx == rx) {
        arr[lx] = num;
    } else {
        int m = (lx + rx) / 2;

        Build(x + x, lx, m, num, k - 1);

        if (v[k - 1].empty()) {
            cout << "-1\n";
            exit(0);
        }

        auto nxt = v[k - 1].upper_bound(num);

        if (nxt == v[k - 1].end()) {
            cout << "-1\n";
            exit(0);
        }

        v[k - 1].erase(nxt);

        Build(x + x + 1, m + 1, rx, *nxt, k - 1);
    }
}

signed main() {
    cin.tie(0); ios_base::sync_with_stdio(0);

    cin >> n;

    unordered_map < int, int > cnt;

    for (int i = 0, x; i < n; i++)
        cin >> x, cnt[x]++;    

    for (auto [x, y] : cnt)
        v[y].insert(x);

    if (v[__lg(n + 1)].empty()) {
        cout << "-1\n";
        return 0;
    }

    int first = *v[__lg(n + 1)].begin();
    v[__lg(n + 1)].erase(first);

    Build(1, 0, n / 2, first, __lg(n + 1));

    for (int i = 0; i <= n / 2; i++)
        cout << arr[i] << " ";
}
