//coded by seeyou
/* @@@@@@@@@@@@@@@@@@@@@@*+++*====*+:::++*===**++:::::::::::::+*@@@@@#####@@@@@@
 @@@@@@@@@@@@@@@@@@@@#+**++*+::::::+==+:::::::::::+****++::::+++#@######@@@@@@@@
 @@@@@@@@@@@@@@@@##@***+++::::+++**+::::::::::+=*++::+++++++:::+:=@=**#@@@@@@@@@
 @@@@@@@@@@@@@@@##=+:--------------------+==#======*+:::::::++::+:=+++:+@@@@@@@@
 @@@@@@@@@@@@@#::+*===*****----:::::::++::::*:+++**=====*+:::::+:+:==*+::*@@@@@@
 @@@@@@@@@@@@#+++==:-.--:+*---:::::+++*=::::*::::::::::+*===+::::+++==*+::+@@@@@
 @@@@@@@@@@#..-.+=:.--:::++---::::+++++++++:*===*++:::::::::+=*:::++===++::+@@@@
 @@@@@@@@@#*--:-++::*====++:::+:++++++++++++*+::++++++++::::::::+::+*#==++:+@#@@
 @@@@@@@@@@:::::*=+=######=*::+=#=++:::+++++**+:::::::::::+++:::::+++#==*+:+@#@@
 @@@@@@@@@@*##=+*##########*::+++++**=*=++++======*+:::::::::::++:::*#===+++@##@
 @@@@@@@@@@@####*###@#####+:::++++++*+****=::++*=========*+++++**++++#===*++@###
 @@@@@@@@@@@@##+=########=+:::++***==#=**++*==*++::+*====+++*====*===@===*:+@##@
 @@@@@@@@@@@#***=#########=====**+++++++++++*==++==*+:::+*==*:::::+*=#====::@##@
 @@@@@@@@@@@@@######=**+++++++=####*++*####+=*+**+:+====*+:::+**+::::#====::##@@
 @@@@@@@@@@@@@@==*++++++=##***#####**+######=#**=====**======*+:::::=====*+:#@@@
 @@@@@@@@@@@@@@@@#=++++##@@@@W##@#****=###*:*=++======#===#=========#====*::=@@@
 @@@@@@@@@@@@@@#=@W#++++#@W@==@WWWW@@@@@@=**=#=**===*+++**+*=======@====*+::=@@@
 @@@@@@@@@@@@@#=**#@*+++***=#*+=#@@@@#==**==:+**+*#+++*===++======#@==*=++::=@@@
 @@@@@@@@@@@@@@=++*+++++*+=**+::++++*#=++++*==*+**+++++**+++======@@==*=:++:=#@@
 @@@@@@@@@@@@@@=*++++++++*=##++++++++=####++===++++++=====++=====@@#==**+:=:=##@
 @@@@@@@@@@@@@@*++++++++*####=++##+++#####++==**+++++*==*++*===#@@@#==*++*#:##@@
 @@@@@@@@@@@@@#++++++++++=###*++++++++***+++:+**+++****+++*====#@@@#=**::@#+##@@
 @@@@@@@@@@@@@@@*#*++++++++++++++++++++++++*#=***++++:++=#=====@@@@@=*+:=@#*@@@@
 @@@@@@@@@@@@@@@#+=*++++++++++++++++++++++++**=+++++*=###====#@@@@@@=++=@@==@@@@
 @@@@@@@@@@@@@@:*=**++++++++++++++++++++++++##==@#=##====##==@#@@@@@#+#@@@=@@@@@
 @@@@@@@@@@@@@@@*=*+#@===*****=*++++++++++++:**=#==+++++*=###@@@@@###*#@@@#@@@@@
 @@@@@@@@@@@@@@#*=@++++++***+++++++++++++++*#####*+++++++++=#@W@W@@@@==@@@@@@@@@
 @@@@@@@@@@@@@@++**@*+====*+++++++++++++++=###=*++*=##=*+++++++++#@@@@*@@@@@@@@@
 @@@@@@@@@@@@@@#+=@@@+++++++++++++++++*==#:+*==*+++++++++++++++++=@@@@@#@@@@@@@@
 @@@@@@@@@@@@@@@#=@@@=++++++++++++==#####==#=**+++++++++*=##@@@@@@W@@@@@@@@@@@@@
 @@@@@@@@@@@@@@=***@@@@=****=#@W@###===##**==+++*=#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 @@@@@@@@@@@@@@@##@@@@@@@@@@@@######==#*+*#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 W@@@@@@@@@@@@@@#=@@@@@@@@W#########@W@####@@@@@@@@@@@@@@@@@@@@@@@WW@@@@@@@@@@@@
 WW@@@@@@@@@@@@====@@@@@@@@###@WWWWW@@==@@@@@@@@@@@@@@@@@@@@@@@WWWWW@@@W@@@@@@@@
 WWWW@@@@@@@@@@@#@@@@@@@@@@WWWWWWW@**=@@@@@@@@@@@@@@@@@@@@WWWWWWWWW@@W@@@@@@@@@@
 WWWWWWWW@@@@@@@==@@@@WW@@@@@WWWW#=#@@WWWWWWWWWWWWWWWWWWWWWWW@@@@@@@@WW@@@W@@@@W
 WWWWWWWW@@@@@@@###@WW@@@@@@@@@@@@@@@@@@@@WWWWWWWWWWWWWWWWWWWWWWWWWWWW@@@@WW@@@@
 WWWWWWWWW@@@@@@##@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@W@@@
 WWWWWWWWW@WWW@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 WWWW@#=====****************=##@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 */
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <numeric>
#include <queue>
#include <set>

using namespace std;

#define all(x) x.begin(), x.end()
#define ll long long
#define en endl;


void solve () {
    int n, m;
    cin >> n >> m;
    
    vector<int> c(m);
    map<int, int> count_map;
    
    for (int i = 0; i < m; i++) {
        cin >> c[i];
        count_map[c[i]]++;
    }
    
    vector<int> result;
    
    for (auto it = count_map.begin(); it != count_map.end(); ++it) {
        if (it->second == n || it->second == n + 1) {
            result.push_back(it->first);
        }
    }
    
    cout << result.size() << endl;
    
    for (int i = 0; i < result.size(); i++) {
        cout << result[i];
        if (i < result.size() - 1) {
            cout << " ";
        }
    }
}
int main () {
        solve();
    }
