def calculate_average_cost(data):
    service_cost = {}
    days = 0
    total_cost = 0
    
    # Собираем данные о стоимости услуг и суммируем общую стоимость за каждый день
    for entry in data:
        service, cost = entry
        if service != ' ':
            if 'проживание' in service.lower():
                days += 1
            if service in service_cost:
                service_cost[service] += cost
            else:
                service_cost[service] = cost
            total_cost += cost
    
    # Рассчитываем среднюю стоимость за день
    average_cost = total_cost / days
    return average_cost

# Пример использования функции
journal = [['услуга', 'стоимость'],
           ['проживание (стандарт)', 100],
           ['такси', 50],
           [' ', 0],
           ['завтрак', 30],
           ['проживание (люкс)', 200],
           [' ', 0],
           ['ужин', 70]]

average_cost = calculate_average_cost(journal)
print("Средняя стоимость проживания в отеле за день:", average_cost)
