def find_kth_task(n, q, k, permutation, changes):
    for l, r in changes:
        priority = list(range(1, r - l + 2))
        priority.reverse()
        for i in range(l - 1, r):
            permutation[i] = priority[i - l + 1]
    sorted_tasks = sorted(range(n), key=lambda x: permutation[x])
    return sorted_tasks[k - 1] + 1
n, q, k = map(int, input().split())
permutation = list(map(int, input().split()))
changes = []
for _ in range(q):
    l, r = map(int, input().split())
    changes.append((l, r))
result = find_kth_task(n, q, k, permutation, changes)
print(result)


