n = int(input())
values = list(map(int, input().split()))

# Создайте массив для восстановленного дерева отрезков, изначально заполненный бесконечностью.
tree = [float('inf')] * n

# Заполните массив значениями из листьев дерева отрезков.
for i in range(n):
    tree[i] = values[i]

# Восстанавливайте дерево отрезков, начиная с корня и двигаясь в глубину.
for i in range(n - 1, -1, -1):
    left_child = 2 * i + 1
    right_child = 2 * i + 2
    if right_child < n:
        tree[i] = min(tree[left_child], tree[right_child])

# Если значение в корне равно минимальному элементу массива, то можно восстановить исходный массив.
if tree[0] == min(values):
    print(" ".join(map(str, values)))
else:
    print("-1")
