n, q, k = map(int, input().split())
permutation = list(map(int, input().split()))
changes = [0] * n

for _ in range(q):
    l, r = map(int, input().split())
    changes[l - 1] += 1
    if r < n:
        changes[r] -= 1

for i in range(1, n):
    changes[i] += changes[i - 1]

sorted_permutation = [0] * n
for i in range(n):
    sorted_permutation[i] = (permutation[i], i + 1)

sorted_permutation.sort(key=lambda x: (x[0], -x[1]))

result = sorted_permutation[k - 1][1]
print(result)
