#include <bits/stdc++.h>
using namespace std;
using ll = long long;
mt19937_64 rnd(time(0));
#define push_back pb
#define make_pair mp
#define F first
#define S second
#define all(x) x.begin(), x.end()

const ll N = 2e5 + 5;
const ll INF = 1e15;

vector<ll> dx = {0, 1, 0, -1};
vector<ll> dy = {1, 0, -1, 0};

vector<ll> diagx = {1, 1, -1, -1};
vector<ll> diagy = {1, -1, -1, 1};

vector<string> a;
const ll n = 10, m = 10;

vector<vector<bool>> used(n, vector<bool> (n));

ll mx_x, mx_y, mn_x, mn_y, area;

void dfs(ll x, ll y) {
    mx_x = max(mx_x, x);
    mn_x = min(mn_x, x);
    mx_y = max(mx_y, y);
    mn_y = min(mn_y, y);
    area++;
    used[x][y] = true;

    for (int i = 0; i < 4; i++) {
        ll nx = x + dx[i], ny = y + dy[i];
        if (0 <= nx && nx < n && 0 <= ny && ny < m && !used[nx][ny] && a[nx][ny] == '#') {
            dfs(nx, ny);
        }
    }
}

void solve() {
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    bool check = true;
    vector<ll> cnt(100, 0);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '#' && !used[i][j]) {
                mx_x = i; mn_x = i;
                mx_y = j; mn_y = j;
                area = 0;
                dfs(i, j);

                ll cx = mx_x - mn_x + 1;
                ll cy = mx_y - mn_y + 1;
                if (min(cx, cy) != 1) {
                    check = false;
                }
                if (area > 4) {
                    check = false;
                }
                cnt[area]++;
            }
        }
    }
    if (cnt[1] != 4 || cnt[2] != 3 || cnt[3] != 2 || cnt[4] != 1) {
        check = false;
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == '#') {
                for (int h = 0; h < 4; h++) {
                    ll nx = i + diagx[h], ny = j + diagy[h];
                    if (0 <= nx && nx < n && 0 <= ny && ny < m && a[nx][ny] == '#') {
                        check = false;
                    }
                }
            }
        }
    }

    if (check) cout << "YES" << '\n';
    else cout << "NO" << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    solve();

    return 0;
}