//Only for _prince_
#include <iostream>
#import  <cmath>
#import <algorithm>
#import <string>
#import <set>
#import <vector>
#import <map>
#import <cstring>
#import <iomanip>
#import <fstream>
using namespace std;
using ull = unsigned long long int;
#define sz(x) int((x).size())
#define all(x) (x).begin(), (x).end()
#define endl '\n'
#define int long long
const int mod = 1e9+7;
void in(){
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}
void result(){
    int n = 10;
    int cnt = 0;
    vector<vector<char>> s(n+2, vector<char>(n+2, '.'));
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= n; ++j){
            cin >> s[i][j];
            if(s[i][j] == '#') cnt ++;
        }
    }
    if(cnt != 20){
        cout << "NO";
        return;
    }
    int dx[] = {1,1, -1, -1};
    int dy[] = {-1, 1, 1, -1};
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= n; ++j){
            if(s[i][j] == '#'){
                if((s[i+1][j] == '#' || s[i-1][j] == '#') && (s[i][j+1] == '#' || s[i][j-1] == '#')){
                    cout << "NO";
                    return;
                }
                for(int k = 0; k < 4; ++k)
                    if(s[i+dx[k]][j+dy[k]] == '#'){
                        cout << "NO";
                        return;
                    }
            }
        }
    }
    map<int, int> mp;
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= n; ++j){
            if(s[i][j] == '#'){
                int k, c = 0;
                if(s[i+1][j] == '#'){
                    k = i;
                    while(k <= n && s[k][j] == '#'){
                        s[k][j] = '.';
                        c++;
                        k++;
                    }
                } else if(s[i][j+1] == '#'){
                    k = j;
                    while(k <= n && s[i][k] == '#'){
                        s[i][k] = '.';
                        c++;
                        k++;
                    }
                } else c = 1, s[i][j] = '.';
                mp[c] ++;
            }
        }
    }
    if(mp.size() != 4){
        cout << "NO";
        return;
    }
    for(auto [x, y]: mp){
    //        cout << x << ' ' << y << endl;
        if(x+y != 5){
            cout << "NO";
            return;
        }
    }
    cout << "YES";
}
signed main(){
    cin.tie(0)->sync_with_stdio(0);
    int r = 1;
    // cin >> r;
    while(r--) {
        result();
        cout << '\n';
    }
}
/*
  ╔═══╗╔═══╗╔══╗╔═╗─╔╗╔═══╗╔═══╗
  ║╔═╗║║╔═╗║╚╣─╝║║╚╗║║║╔═╗║║╔══╝
  ║╚═╝║║╚═╝║─║║─║╔╗╚╝║║║─╚╝║╚══╗
  ║╔══╝║╔╗╔╝─║║─║║╚╗║║║║─╔╗║╔══╝
  ║║───║║║╚╗╔╣─╗║║─║║║║╚═╝║║╚══╗
  ╚╝───╚╝╚═╝╚══╝╚╝─╚═╝╚═══╝╚═══╝
*/
