n, m = map(int, input().split())
r = float(input())

days = []
for _ in range(n):
    d, w = map(int, input().split())
    days.append((d, w))

days.sort(key=lambda x: x[0])  # Сортируем дни производства по номерам дней

inspection_days = list(map(int, input().split()))
inspection_days_set = set(inspection_days)

waste = 0.0  # Начинаем с нулевых отходов
output = []

index = 0
for i in range(1, max(inspection_days) + 1):
    while index < len(days) and days[index][0] == i:
        waste = waste * (1 - r) + days[index][1] * r
        index += 1
    if i in inspection_days_set:
        output.append(waste)

for result in output:
    print(result)
