h, w = map(int, input().split())
dp = [[0] * (w + 1) for _ in range(h + 1)]

for i in range(1, h + 1):
    for j in range(1, w + 1):
        dp[i][j] = i * j  # Максимальная площадь для пустой витрины
        for x in range(1, i):
            dp[i][j] = max(dp[i][j], dp[x][j] + dp[i - x][j])  # Разбиваем витрину по вертикали
        for y in range(1, j):
            dp[i][j] = max(dp[i][j], dp[i][y] + dp[i][j - y])  # Разбиваем витрину по горизонтали

print(dp[h][w])
